%global hash 7a/72/2e8f1f1902a50ac84560a2a976b248599e177333413d45c50b7392e20a14
%global use_systemd 1

Summary: A simple-to-use and -install issue-tracking system with command-line, web and e-mail interfaces. Highly customisable.
Name: roundup
Version: 1.6.1
Release: 1%{dist}
Source0: https://files.pythonhosted.org/packages/%{hash}/%{name}-%{version}.tar.gz
Source1: roundup.service
Patch: %{name}-1.4.patch
License: BSD2 and ZPL
Group: Development/Libraries
BuildRoot: /var/tmp/%{name}-%{version}-%{release}-buildroot
BuildRequires: python2
%if %{use_systemd}
# systemd macros are not defined unless systemd is present
BuildRequires: systemd
Requires: systemd
Requires(post): systemd
Requires(preun): systemd
Requires(postun): systemd
%else
Requires: chkconfig
%endif
Prefix: %{_prefix}
BuildArch: noarch
Vendor: Richard Jones <richard@users.sourceforge.net>
Url: http://www.roundup-tracker.org

%description
I’m proud to release version 1.6.1 of Roundup which has been possible due to
the help of several contributors. This release is a bug fix release. If you are
upgrading from a release earlier than 1.6.0 it includes important security
enhancements, so make sure to read docs/upgrading.txt to bring your tracker up
to date

%prep
%setup -n %{name}-%{version}
#patch -p1 -b .bms

%build
python2 setup.py build

%install
python2 setup.py install --root=%{buildroot} 
TRACKER=%{buildroot}/var/lib/roundup
mkdir -p $TRACKER
%if %{use_systemd}
mkdir -p %{buildroot}%{_unitdir}
cp -p %{SOURCE1} %{buildroot}%{_unitdir}
%else
chmod a+x start.sh roundup.rc
cp -p start.sh $TRACKER
mkdir -p %{buildroot}/etc/rc.d/init.d
cp -p roundup.rc %{buildroot}/etc/rc.d/init.d/roundup
# create /var/run/roundup
mkdir -p %{buildroot}/var/run/roundup
mkdir -p %{buildroot}%{_sysconfdir}/tmpfiles.d
cat >%{buildroot}%{_sysconfdir}/tmpfiles.d/roundup.conf <<EOF
D /var/run/roundup 0755 roundup roundup -
EOF
%endif
mkdir -p %{buildroot}/etc/smrsh
ln -sf /usr/bin/roundup-mailgw %{buildroot}/etc/smrsh
cp -p doc/roundup-server.ini.example $TRACKER/roundup-server.ini

%pre
/usr/sbin/useradd -s /sbin/nologin -d /var/lib/roundup \
	-c "Classic Roundup Tracker" roundup >/dev/null 2>&1 || :
%if %{use_systemd}

%post
%systemd_post cjdns.service

%postun
%systemd_postun_with_restart cjdns.service

%preun
%systemd_preun cjdns.service

%else

%post
/sbin/chkconfig --add roundup >/dev/null 2>&1 || :

%preun
if [ $1 = 0 ]; then
  /sbin/chkconfig --del pysrs
fi

%endif

%files
%defattr(-,root,root)
%doc doc/*
%license COPYING.txt
%dir %attr(0755,roundup,roundup)/var/lib/roundup
%config(noreplace) /var/lib/roundup/roundup-server.ini
%if %{use_systemd}
%{_unitdir}/*
%else
/var/lib/roundup/start.sh
%dir %attr(0755,roundup,roundup)/var/run/roundup
%{_sysconfdir}/rc.d/init.d/roundup
%{_sysconfdir}/tmpfiles.d/roundup.conf
%endif
%{python2_sitelib}/*
%{_bindir}/*
%{_sysconfdir}/smrsh/roundup-mailgw
%{_datadir}/locale/*/*/*
%{_datadir}/roundup
%{_datadir}/doc/roundup
%{_mandir}/man1/*

%changelog
* Thu Feb  6 2020 Stuart Gathman <stuart@gathman.org> 1.6.1-1
- CentOS-7.7
- New upstream release

* Tue Sep 19 2017 Stuart Gathman <stuart@gathman.org> 1.4.20-5
- CentOS-7.4
- Systemd service

* Fri Sep  8 2017 Stuart Gathman <stuart@gathman.org> 1.4.20-4
- RPM release for CentOS-7.3

* Tue Jun 26 2012 Stuart Gathman <stuart@bmsi.com> 1.4.20-1
- RPM release for CentOS-6.2
  Features:
- Experimental support for the new Chameleon templating engine.
  We now have two configurable templating engines, the old Zope TAL
  templates (called zopetal in the config) and the new Chameleon (called
  chameleon in the config). A new config-option "template_engine" under
  [main] can take these config-options, the default is zopetal.
  Thanks to Cheer Xiao for the idea of making this configurable *and*
  for the actual implementation! (Ralf)
  WARNING: Chameleon support is highly experimental and *not* recommended for
  production use. It has known performance issues and i18n is not yet
  functioning. It's still under active development. Only use this feature if
  you want to experiment with Chameleon and/or help with Roundup
  developement. If you found a bug in Chameleon support, please report after
  testing against latest Roundup source from the Mercurial repository.
- issue2550678: Allow pagesize=-1 which returns all results.
  Suggested and implemented by John Kristensen. 
  Tested by Satchidanand Haridas. (Bernhard)
- Allow to turn off translation of generated html options in menu method
  of LinkHTMLProperty and MultilinkHTMLProperty -- default is
  translation as it used to be (Ralf)
- Sending of OpenPGP encrypted mail to all users or selected users (via
  roles) is now working. (Ralf)
- Add config-option "nosy" to messages_to_author setting in [nosy]
  section of config: This will send a message to the author only
  in the case where the author is on the nosy-list (either added
  earlier or via the add_author setting). Current config-options
  for this setting will send / not send to author without considering
  the nosy list. (Ralf)
  Bugs:
- issue2550730: FAQ has broken link to Zope book. Reported and fixed by
  John Rouillard.(Bernhard)
- issue2550728: remove buggy parentheses in TAL/DummyEngine.py.
  Reported and fixed by Ralf Hemmecke. (Bernhard)
- issue2550715: IndexError when requesting non-existing file via http.
  Reported and fixed by Cedric Krier. (Bernhard)
- issue2550712: exportcsvaction errors poorly when given invalid columns.
  Reported by Will Kahn-Greene, fixed by Cedric Krier. (Bernhard)
- issue2550695: 'No sort or group' settings not retained when editing queries.
  Reported and fixed by John Kristensen. Tested by Satchidanand Haridas. 
  (Bernhard)
- Fix matching of incoming email addresses to the alternate_addresses
  field of a user -- this would match substrings, e.g. if the user has
  discuss-support@example.com as an alternate email and an incoming mail
  is addressed to support@example.com this would (wrongly) match. (Ralf)
- issue2550729: Fix password history display for anydbm backend, thanks
  to Ralf Hemmecke for reporting. (Ralf)
- OpenPGP support is again working (pyme API has changed significantly) and
  we now have a regression test. We now take care that bounce-messages
  for incoming encrypted mails or mails where the policy dictates that
  outgoing traffic should be encrypted is actually OpenPGP encrypted. (Ralf)
- Ignore confirm set() fields by themselves in the absence of non-"confirm"
  values; otherwise a bare confirm field can be used to change the a
  password. Reported by Cam Blackwood. (Ralf)
- Updated version of simplified Chinese message file by Cheer Xiao:
  Corrected some mistakes, added a few more items and did some
  formating. (Ralf)
- Fix xmlrpc URL parsing so that passwords may contain a ':' character
  (Ralf)
- Be more tolerant when parsing RFC2047 encoded mail headers. Use
  backported version of my proposed changes to
  email.header.decode_header in http://bugs.python.org/issue1079
  (Ralf)
- issue2550684 Fix XSS vulnerability when username contains HTML code,
  thanks to Thomas Arendsen Hein for reporting and patch. (Ralf)
- issue2550711 Fix XSS vulnerability in @action parameter,
  thanks to "om" for reporting. (Ralf)
- issue2550535 In some cases even when keep_quoted_text=yes is
  configured we would strip quoted sections. This hit the python
  bug-tracker especially for python interpreter examples with leading
  '>>>' strings. The fix is slightly different compared to the proposal
  as this broke keep_quoted_text=no in certain cases. We also fix a bug
  where keep_quoted_text=no would drop the last line of a non-quoted
  section if there wasn't an empty line between the next quotes. (Ralf)
- issue2431638 wrong registration link in bounce mail for non-registered
  users reported *years* ago by anonymous (Ralf)
- Fix doc/upgrading.txt which produces errors with latest docutils about
  wrong block structure. Fix .gitignore in doc directory. Thanks to
  Cheer Xiao for the patches. (Ralf)
- Fix wrong execute permissions on some files, thanks to Cheer Xiao for
  the patch. (Ralf)
- Fix override of TemplatingUtils in instance.py, thanks to Cheer Xiao
  for the patch. (Ralf)
- Fix another XSS with the "otk" parameter, thanks to Jesse Ruderman for
  reporting. (Ralf)
- Mark cookies HttpOnly and -- if https is used -- secure. Fixes
  issue2550689, but is untested if this really works in browsers.
  Thanks to Joseph Myers for reporting. (Ralf)
- Fix another XSS with the ok- and error message, see issue2550724. We
  solve this differently from the proposals in the bug-report by not
  allowing *any* html-tags in ok/error messages anymore. Thanks to 
  David Benjamin for the bug-report and to Ezio Melotti for several
  proposed fixes. (Ralf)
